<?php
/*
Plugin Name: MPVC
Version: 1.2
Description: Plugin permettant de modifier la classe des deux paragraphes utilise dans les vignettes de categorie (le nombre d'images ainsi que le commentaire) et les mettre en forme de facon plus personnelle
Plugin URI: http://phpwebgallery.net/ext/extension_view.php?eid=170
*/

/* ----------------------------------------------------------------------
  Plugin réalisé selon le tutoriel de flipflip 
  http://phpwebgallery.net/doc/doku.php/fr:utiliser:faire_un_plugin

1.0                - version initale
1.0.a              - ajout de l'URI pour compatibilité avec UpToD@te
1.1   - 16/10/2007 + modification de la feuille de style pour être adaptée à tout type thèmes 
1.2   - 18/10/2007 + la feuille de style est enregistrée dans un fichier css
                   + la feuille de style n'est chargée que si nécessaire
                   + passage en multilangues
   ---------------------------------------------------------------------- */

if (!defined('PHPWG_ROOT_PATH')) die('Hacking attempt!');
// ini_set('error_reporting', E_ALL);
// ini_set('display_errors', true);

define('MPVC_VERSION' , '1.2');
define('MPVC_DIR' , basename(dirname(__FILE__)));
define('MPVC_PATH' , PHPWG_PLUGINS_PATH . MPVC_DIR . '/');


global $page;

class MPVC_Plugin
{ 
  var $my_config;
  var $plugin_name;

  function MPVC_Plugin()
  {
    $this->plugin_name="MPVC";
    $this->load_config();
    if(!file_exists(dirname(__FILE__)."/mpvc.css"))
    {
      $this->make_CSS();
    }
  }

  /* charge la configuration dans le fichier data.dat */
  function load_config()
  {
    $x = @file_get_contents( dirname(__FILE__).'/data.dat' );
    if ($x!==false)
    {
        $c = unserialize($x);
        $this->my_config = $c;
    }

    if((!isset($this->my_config)))
    {
      // noms par défaut des classes 
      $this->my_config['MPVC_CSSId_NbImg'] = 'MPVC_NbImg';
      $this->my_config['MPVC_CSSId_Comment'] = 'MPVC_Comment';
      // valeurs par défaut des classes     
      $this->my_config['MPVC_NbImg'] = 'font-style: italic;';
      $this->my_config['MPVC_Comment'] = 'text-align:justify;
padding-top:8px;
padding-right:8px;
border-top:1px solid #404040;';
      $this->save_config();
    }
  }
  


  /* sauvegarde de la configuration dans data.dat */
  function save_config()
  {
   $file = fopen( dirname(__FILE__).'/data.dat', 'w' );
   fwrite($file, serialize($this->my_config) );
   fclose( $file );
  }

  function make_CSS()
  {
    $text = "";

    if(($this->my_config['MPVC_CSSId_NbImg']!='')
       and($this->my_config['MPVC_NbImg']!=''))
    { 
      $text.='#content div.thumbnailCategory div.description p.'.
              $this->my_config['MPVC_CSSId_NbImg'].' { '.
              $this->my_config['MPVC_NbImg'].' }'.chr(13).chr(10); 
    }

    if(($this->my_config['MPVC_CSSId_Comment']!='')
      and($this->my_config['MPVC_Comment']!=''))
    { 
      $text.='#content div.thumbnailCategory div.description p.'.
              $this->my_config['MPVC_CSSId_Comment'].' { '.
              $this->my_config['MPVC_Comment'].' }'; 
    }

    if($text!="")
    {
      $handle=fopen(dirname(__FILE__)."/mpvc.css", "w");
      if($handle)
      {
        fwrite($handle, $text);
        fclose($handle);
      }
    }
  }


  /* intégration du plugin dans l'interface d'administration */
  function plugin_admin_menu($menu)
  {
   array_push($menu,
              array(
                  'NAME' => 'MPVC',
                  'URL' => get_admin_plugin_menu_link(dirname(__FILE__).'/admin/MPVC_admin.php')
                   ));
   return $menu;
  }


  /* ajoute la déclaration CSS dans la page */
  function apply_CSS()
  {
    global $template;

    $template->assign_block_vars('head_element', 
      array('CONTENT' => 
              '<link rel="stylesheet" type="text/css" href="plugins/'.
                basename(dirname(__FILE__)).'/mpvc.css">'));
  }


  /* modifie les paragraphes des vignettes de catégories */
  function Modifie_vignette($content) 
  {
    if($this->my_config['MPVC_CSSId_NbImg']!='')
    { $this->personal_replace_tpl_code('mainpage_categories', '<p>{categories.category.CAPTION_NB_IMAGES}', '<p class="'.$this->my_config['MPVC_CSSId_NbImg'].'">{categories.category.CAPTION_NB_IMAGES}&nbsp;'); }

    if($this->my_config['MPVC_CSSId_Comment']!='')
    { $this->personal_replace_tpl_code('mainpage_categories', '<p>{categories.category.DESCRIPTION}', '<p class="'.$this->my_config['MPVC_CSSId_Comment'].'">{categories.category.DESCRIPTION}&nbsp;'); }
  }


  /* remplace un bout de code d'un template */
  function personal_replace_tpl_code($tlp_handle, $old, $new)
  {
   global $template;
   $template->loadfile($tlp_handle);
   $template->uncompiled_code[$tlp_handle] = str_replace($old, $new, $template->uncompiled_code[$tlp_handle]);
  }
}

if(basename($_SERVER["PHP_SELF"])=='admin.php')
{
  $obj = new MPVC_Plugin();
  add_event_handler('get_admin_plugin_menu_links', array(&$obj, 'plugin_admin_menu') ); 
  set_plugin_data($plugin['id'], $obj);
}
elseif(basename($_SERVER["PHP_SELF"])=='index.php')
{
  $obj = new MPVC_Plugin();
  add_event_handler('loc_index_category_thumbnail', array(&$obj, 'Modifie_vignette')); 
  add_event_handler('loc_end_page_header', array(&$obj, 'apply_CSS'));
  set_plugin_data($plugin['id'], $obj);
}


?>
